image: gradle:7.6-jdk17

stages:
  - test
  - publish

# Run tests
test:
  stage: test
  script:
    - gradle check

# Publish artifacts
publish:
  stage: publish
  rules:
    - if: $CI_COMMIT_TAG
      when: never
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
  script:
    - gradle publish
  needs:
    - release

prepare_publish:
  image: alpine
  stage: publish
  rules:
    - if: $CI_COMMIT_TAG
      when: never
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
  script:
    - echo "BUILD_VERSION=$(grep 'version' gradle.properties | cut -d '=' -f 2)" >> variables.env
  artifacts:
    reports:
      dotenv: variables.env

# Make release
release:
  image: registry.gitlab.com/gitlab-org/release-cli:latest
  stage: publish
  rules:
    - if: $CI_COMMIT_TAG
      when: never
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
  needs:
    - prepare_publish
  script:
    - echo "Making release $BUILD_VERSION"
  release:
    tag_name: '$BUILD_VERSION'
    description: 'Release $BUILD_VERSION'
    ref: '$CI_COMMIT_SHA'
